property pMainInfoList
global gObjList, gMachineSpeed, gObj1, gObj2, gObj3, gObj5

on new me
  return me
end

on scrollRow me, info
  set whichRow to getAt(info, 1)
  set direction to getAt(info, 2)
  set theRowSprite to 58 + whichRow
  set the memberNum of sprite theRowSprite to the memberNum of sprite theRowSprite + direction
  update(sprite(theRowSprite))
  updateStage()
end

on countRows me, fromWhere
  set theInfoList to []
  set prevRowCount to 0
  repeat with i = fromWhere to the maxinteger
    set theMemb to member i of castLib 3
    if the type of theMemb = #bitmap then
      set x to count(getData(script the number of member theMemb))
      add(theInfoList, x + prevRowCount)
      set prevRowCount to prevRowCount + x
      next repeat
    end if
    exit repeat
  end repeat
  return theInfoList
end

on initRows me, direction, fromWhichBtn
  repeat with i = 0 to 2
    set the member of sprite (59 + i) to member ((i * 50) + 3001) of castLib 3
    update(sprite(59 + i))
  end repeat
end

on addGraphic me, graphicNo, rowNo
  if the spriteCount of gObj1 < the spriteMax of gObj1 then
    set theMemb to member graphicNo of castLib 3
    if rowNo = 3 then
      if the name of theMemb starts "b." then
        set balloonType to value(char 3 to length(the name of theMemb) of the name of theMemb)
        set balloonSubList to getAt(the balloonList of gObj3, balloonType)
        if not (max(balloonSubList) = 0) then
          set balloonID to max(balloonSubList)
          setAt(balloonSubList, getOne(balloonSubList, balloonID), 0)
          set theMemb to member balloonID of castLib 3
          set offset to point(the width of member theMemb / 2, the height of member theMemb / 2)
        else
          tell window 1
            displayDialog(4)
          end tell
          set balloonType to 0
          exit
        end if
      end if
    end if
    set the spriteCount of gObj1 to the spriteCount of gObj1 + 1
    set theSprite to the spriteCount of gObj1
    if (theSprite < 1) or (theSprite > 50) then
      put "spriteProblem: " & theSprite
    end if
    if balloonType then
      set the isBalloon of sprite(theSprite) to balloonType
      set the balloonID of sprite(theSprite) to balloonID
      set the balloonProps of sprite(theSprite) to getDefaultBalloonProps(gObj3, balloonType)
      updateBalloonContents(gObj3, theSprite)
    else
      set the isBalloon of sprite(theSprite) to 0
    end if
    set the member of sprite theSprite to theMemb
    set the imageTouched of gObj2 to 1
    set the documentTouched of gObj5 to 1
  else
    tell window 1
      displayDialog(3)
    end tell
    exit
  end if
  set defaultLoc to point(403 - (the width of theMemb / 2), 100 - (the height of theMemb / 2)) + offset
  set maxH to getAt(the frameRect of gObj2, 3) - 15
  set maxV to getAt(the frameRect of gObj2, 4) - 15
  set end to the spriteCount of gObj1 - 1
  set equalsList to []
  repeat with i = 1 to end
    if the memberNum of sprite i = the memberNum of theMemb then
      add(equalsList, the loc of sprite i)
    end if
  end repeat
  repeat with i = count(equalsList) down to 1
    if not getOne(equalsList, defaultLoc) then
      exit repeat
    end if
    set defaultLoc to defaultLoc + [10, 5]
    if the locH of defaultLoc > maxH then
      set the locH of defaultLoc to getAt(the frameRect of gObj2, 1) + 2
    end if
    if the locV of defaultLoc > maxV then
      set the locV of defaultLoc to getAt(the frameRect of gObj2, 2) + 2
    end if
  end repeat
  puppetSound(1, "addGraphic")
  set the loc of sprite theSprite to defaultLoc
  updateStage()
  selectGraphic(gObj1, theSprite, 1)
end

on adjustSound me
  tell window 1
    displayDialog(15)
  end tell
end
