property myNum, mySprite, myLocList, memberOffset, myBarData, myRowMemberOffset, maxBars
global gObj1, gObj4

on beginSprite me
  set t to []
  set mySprite to the currentSpriteNum
  set myBarData to countRows(gObj4, 3001 + ((myNum - 1) * 50))
  set myRowMemberOffset to 3001 + ((myNum - 1) * 50)
  set maxBars to count(myBarData) - 1
  set the member of sprite mySprite to member myRowMemberOffset of castLib 3
  update(me, 1)
end

on mouseDown me
  set thePos to findPosNear(myLocList, the locH of the clickLoc - the left of sprite mySprite)
  if thePos > count(myLocList) then
    if (the locH of the clickLoc - the left of sprite mySprite) > getLast(myLocList) then
      deselectAll(gObj1)
      exit
    end if
  end if
  addGraphic(gObj4, ((thePos + memberOffset) * 2) - 1, myNum)
end

on mouseUp me
end

on update me, init
  set theNumber to the memberNum of sprite mySprite
  set rowOffset to theNumber - myRowMemberOffset
  set previousBtn to the mySprite of me + myNum + 8
  set nextBtn to the mySprite of me + myNum + 9
  if rowOffset then
    if rowOffset = maxBars then
      disable(sprite(nextBtn))
    else
      enable(sprite(nextBtn))
    end if
    enable(sprite(previousBtn))
    set memberOffset to ((myNum - 1) * 500) + getAt(myBarData, rowOffset)
  else
    if not init then
      disable(sprite(previousBtn))
      enable(sprite(nextBtn))
    end if
    set memberOffset to (myNum - 1) * 500
  end if
  set myLocList to getData(script theNumber of castLib 3)
  sort(myLocList)
end

on getPropertyDescriptionList me
  return [#myNum: [#comment: "type:", #range: [1, 2, 3], #format: #integer, #default: 1]]
end
