property mySprite, curs, myFrameNum, myDoubleClickTimer
global gObjList, gObj1, gObj2

on beginSprite me
  set mySprite to the currentSpriteNum
  set myFrameNum to mySprite - 100
  set curs to 0
end

on mouseEnter me
  if myFrameNum = the currentFrameNo of gObj2 then
    cursor(260)
  else
    cursor(-1)
  end if
end

on mouseLeave me
  cursor(-1)
end

on update me, check
  set pageLayoutData to getAt(the pageLayoutList of gObj2, myFrameNum)
  if not listp(pageLayoutData) then
    set the member of sprite mySprite to member 141
    set the locH of sprite mySprite to 9000
  else
    set the member of sprite mySprite to member (200 + myFrameNum) of castLib 2
    set the loc of sprite mySprite to point((myFrameNum - 1) mod 3 * 42, (myFrameNum - 1) / 3 * 42) + [41, 24]
    if myFrameNum = the currentFrameNo of gObj2 then
      set the memberNum of sprite 114 to 142 + the pCurrentFrameSize of gObj2
      set the loc of sprite 114 to the loc of sprite mySprite
    end if
  end if
end

on mouseDown me
  set previousFrameNo to the currentFrameNo of gObj2
  set zoom to not (previousFrameNo = myFrameNum)
  if zoom then
    update(sprite(previousFrameNo + 100))
    set delayTime to the ticks + 10
    storeFrameData(gObj2)
    repeat while the mouseDown
      if the ticks > delayTime then
        set probablyDrag to 1
        exit repeat
      end if
    end repeat
  else
    set probablyDrag to 1
  end if
  if probablyDrag then
    if the optionDown then
      set optionDrag to 1
    end if
    set offset to the clickLoc - the loc of sprite mySprite
    set oldLoc to point(0, 0)
    set theMemb to the member of sprite mySprite
    set tempPageLayoutList to duplicate(the pageLayoutList of gObj2)
    set largeFrameSize to getAt(getAt(tempPageLayoutList, myFrameNum), 1) = 2
    if not optionDrag then
      setAt(tempPageLayoutList, myFrameNum, 0)
      if largeFrameSize then
        setAt(tempPageLayoutList, myFrameNum + 1, 0)
      end if
      set the locH of sprite mySprite to 9000
    end if
    set the memberNum of sprite 114 to 145 + largeFrameSize
    set the loc of sprite 114 to the loc of sprite mySprite
    set maxH to 173 - the width of theMemb
    cursor(290)
    set validPosition to 0
    set lastPos to myFrameNum - 1
    repeat while the mouseDown
      set newH to max(33, min(the mouseH - the locH of offset, maxH))
      set newV to max(2, min(the mouseV - the locV of offset, 158))
      set newLoc to point(newH, newV)
      update(getAt(gObjList, 1))
      if not (newLoc = oldLoc) then
        set hPos to (newH - 20) / 42
        set vPos to (newV + 4) / 42
        set newPos to hPos + (vPos * 3)
        set click to ((newH + 11) / 21 mod 2) + ((newV + 28) / 21 mod 2)
        set the loc of sprite 114 to newLoc
        set isPosValid to getAt(tempPageLayoutList, newPos + 1) = 0
        if largeFrameSize then
          set isPosValid to max(0, isPosValid - not (getAt(tempPageLayoutList, newPos + 2) = 0))
        end if
        if isPosValid then
          if not click then
            set the loc of sprite 114 to point(newPos mod 3 * 42, newPos / 3 * 42) + [41, 24]
            if not (newPos = lastPos) then
              puppetSound(1, "snapFrame")
              set lastPos to newPos
            end if
          else
            set lastPos to -1
          end if
          set validPosition to newPos + 1
        else
          set validPosition to 0
        end if
        updateStage()
        set oldLoc to newLoc
      end if
    end repeat
  end if
  if the ticks < myDoubleClickTimer then
    changeBorderType(gObj2)
    set myDoubleClickTimer to 0
  else
    set myDoubleClickTimer to the ticks + 17
  end if
  if probablyDrag and validPosition and (click = 0) and not (validPosition = previousFrameNo) then
    cursor(260)
    if zoom then
      set the currentFrameNo of gObj2 to previousFrameNo
    else
      storeFrameData(gObj2)
      set the currentFrameNo of gObj2 to validPosition
    end if
    switchFrames(gObj2, myFrameNum, validPosition, zoom, optionDrag)
  else
    if zoom then
      jumpToFrame(gObj2, myFrameNum, 0, "jumpToFrame")
    else
      update(sprite(previousFrameNo + 100))
      update(me)
      if not ((click = 0) and (previousFrameNo = validPosition)) then
        puppetSound(1, "snapFrame")
      end if
      updateStage()
    end if
    cursor(260)
  end if
end
