global gObjList, gObj1, gObj2, gObj3, gObj4, gObj5, gObj6, gPlatForm, gItemSeparator, gTaskBarStatus, gOldColorDepth, gLangCode, gFontName, keyFileFound, g68KThumbnailPatch, traceList

on startMovie
  set traceList to []
  repeat with i = 1 to 2066
    if not (the type of member i of castLib "screenGraphics" = #bitmap) then
      add(traceList, 0)
      next repeat
    end if
    add(traceList, the loaded of member i of castLib "screenGraphics")
  end repeat
  if not (the frame = 1) then
    exit
  end if
  set gFontName to "Comicbook"
  set gItemSeparator to numToChar(1)
  set the windowList to []
  set the visible of window "dialog" to 0
  set the windowType of window 1 to 2
  repeat with i = 1 to 4
    set the media of member (i + 10) of castLib 2 to the media of member (3150 + i) of castLib 3
  end repeat
  repeat with i = 1 to 7
    set the media of member (i + 3) of castLib 2 to the media of member (3156 + i) of castLib 3
    if not (the depth of member (i + 3) of castLib 2 = 1) then
      set alertWrongDepth to the depth of member (i + 3) of castLib 2
    end if
  end repeat
  if alertWrongDepth then
    alert("Balloon dialogMembers are of wrong colordepth!" & RETURN & RETURN & alertWrongDepth)
  end if
  if not (the paletteRef of member the member of sprite 2 = #systemWin) then
    alert("Publisher logo at startup is not in Windows palette!")
  end if
  set the idleHandlerPeriod to 0
  set the exitLock to 1
  set the stageColor to 0
  repeat with i = 201 to 212
    erase(member i of castLib 2)
  end repeat
  set gLangCode to the name of member 1 of castLib 2
  if (gLangCode = EMPTY) or not (length(gLangCode) = 3) then
    alert("No language code present!" & RETURN & RETURN & "member 1")
  end if
  if the platform contains "Mac" then
    set gPlatForm to 1
    if the platform contains "68" then
      set g68KThumbnailPatch to 1
    end if
    if not (the runMode = "author") then
      if not (the number of xtras = 6) then
        alert("CBA2 internal error: Application will only run from original CD!" & RETURN & RETURN & 4 & RETURN & RETURN & the number of xtras)
        quit()
      end if
      OSRegister(454303137, 1046276000)
      if voidp(keyFileFound) and ((OSVolumeFree(getNthOfPath(the moviePath)) / 1024) > 60) then
        alert("CBA2 internal error: Application will only run from original CD!" & RETURN & RETURN & 3)
        quit()
      end if
    else
      if not (the fileName of castLib 4 contains "fileLib") then
        alert("Verkeerde castlib op 4")
      end if
    end if
  else
    set gPlatForm to 0
    if not (the runMode = "author") then
      if not (the number of xtras = 5) then
        alert("CBA2 internal error: Application will only run from original CD!" & RETURN & RETURN & "5" & RETURN & RETURN & "Total:" && the number of xtras)
        quit()
      end if
      baRegister("LASCAUX", 2197975)
      set the media of member 141 of castLib 1 to the media of member 147 of castLib 1
      set the media of member 142 of castLib 1 to the media of member 148 of castLib 1
    end if
  end if
  castFX_register("CFX-ALL-2-19980219-09200303-05647")
  register(xtra("PrintOMatic"), "PMAT155-401-12661")
  set gObj2 to new(script "gObj2 layout")
  set gObj5 to new(script "gObj5 file")
  fontChecks()
  screenChecks()
  updateVersionNo()
end

on fontChecks
  if gPlatForm then
    set the textFont of member "textClipTestField" to gFontName
    if not (the textFont of member "textClipTestField" = gFontName) then
      openXLib("@:supportM:comicbook")
      set the textFont of member "textClipTestField" to gFontName
      if not (the textFont of member "textClipTestField" = gFontName) then
        alert("CBA/2 internal error: could not open font! The font will be copied to the system volume and the application will quit." & RETURN & "Please drag the " & QUOTE & gFontName & QUOTE & "font to your System folder and relaunch this application.")
        set fontDir to getNthOfPath(getOSDirectory())
        set sourceFontDir to the moviePath & "supportM:comicbook"
        set OSerror to OSFileCopy(sourceFontDir, fontDir)
        if OSerror then
          alert("CBA/2 internal error: OS error" && OSerror)
        end if
        quit()
      end if
    end if
  else
    set the textFont of member "textClipTestField" to gFontName
    if not (the textFont of member "textClipTestField" = gFontName) then
      set error to baInstallFont(the moviePath & "supportW\cmicbook.ttf", gFontName)
      if error then
        alert("CBA/2 internal error: Windows font install problem!" & RETURN & RETURN & error)
      end if
      set the textFont of member "textClipTestField" to gFontName
      if not (the textFont of member "textClipTestField" = gFontName) and not error then
        set the locH of sprite 2 to 9000
        puppetPalette("runtimePaletteWin", 60)
        updateStage()
        tell window 1
          displayDialog(16)
        end tell
      end if
    end if
  end if
  repeat with c = 1 to 3
    repeat with i = the number of castMembers of castLib c down to 2
      if the type of member i of castLib c = #field then
        if not (the textFont of member i of castLib c = gFontName) then
          set the textFont of member i of castLib c to gFontName
        end if
      end if
    end repeat
  end repeat
  tell window 1
    repeat with i = 1 to the number of castMembers of castLib 1
      if the type of member i = #field then
        if not (the textFont of member i = gFontName) then
          set the textFont of member i to gFontName
        end if
      end if
    end repeat
  end tell
end

on screenChecks x, fromDialog, mode
  if not fromDialog then
    if not (the colorDepth = 8) then
      if gPlatForm then
        set gOldColorDepth to the colorDepth
        set the locH of sprite 2 to 9000
        updateStage()
        set the colorDepth to 8
        Del(60)
        if not (the colorDepth = 8) then
          tell window 1
            displayDialog(14)
          end tell
        end if
      else
        set currentWidth to baScreenInfo("width")
        set currentHeight to baScreenInfo("height")
        set canBeChanged to baSetDisplay(currentWidth, currentHeight, 8, "test", 0)
        if canBeChanged = 0 then
          tell window 1
            displayDialog(12)
          end tell
        else
          if canBeChanged = 1 then
            tell window 1
              displayDialog(13)
            end tell
          else
            if canBeChanged < 0 then
              tell window 1
                displayDialog(14)
              end tell
            end if
          end if
        end if
      end if
    end if
  else
    if gPlatForm then
      alert("Burp!")
    end if
    set currentWidth to baScreenInfo("width")
    set currentHeight to baScreenInfo("height")
    set oldDepth to the colorDepth
    set isNotChanged to baSetDisplay(currentWidth, currentHeight, 8, mode, 0)
    if isNotChanged = 0 then
      set gOldColorDepth to oldDepth
    else
      if isNotChanged = 1 then
        baExitWindows("reboot")
      else
        if not (isNotChanged = 0) then
          alert("CBA/2 internal error: problem changing monitor depth!" & RETURN & RETURN & isNotChanged)
        end if
      end if
    end if
  end if
end

on startProgram
  cursor(4)
  set gObjList to [new(script "selectRects&cursor")]
  set gObj1 to new(script "gObj1 graphics")
  set gObj3 to new(script "gObj3 balloons")
  set gObj4 to new(script "gObj4 rows")
  set gObj6 to new(script "gObj6 print")
  set the timeoutLength to 120
  set the timeoutScript to "checkThumbs(gObj2)"
  sound fadeOut 3, 80
end

on stopMovie
  if the runMode = "Author" then
    set the trace to 0
    repeat with i = 201 to 212
      duplicate(member 143, member i of castLib 2)
    end repeat
    erase(member 200)
    repeat with i = 1 to 13
      erase(member i of castLib 4)
    end repeat
    repeat with i = 1 to 4
      set the media of member (i + 10) of castLib 2 to the media of member 143 of castLib 1
      set the regPoint of member (i + 10) of castLib 2 to point(20, 40)
    end repeat
    repeat with i = 1 to 7
      set the media of member (i + 3) of castLib 2 to the media of member 143 of castLib 1
    end repeat
    repeat with i = 2000 to 3000
      if the type of member i of castLib 3 = #field then
        put "dummyText" && i into field i of castLib 3
      end if
    end repeat
    set the windowList to []
    set gObjList to 0
    set the stageColor to 255
    set the text of member "title" to "..."
    set the text of member "name" to "..."
    set the text of member "vers" to "..."
    clearGlobals()
  end if
  castFX_shutdown()
  closeXLib()
end

on clearPageLayout
  repeat with i = 1 to 12
    set the locH of sprite (100 + i) to 9000
  end repeat
  set the locH of sprite 114 to 9000
end

on clearFrameLayout me
  repeat with i = 1 to the spriteCount of gObj1
    add(the pUnloadList of gObj2, the memberNum of sprite i)
    set the locH of sprite i to 9000
  end repeat
end

on makeNumber input, pos
  set output to string(input)
  repeat with i = pos - length(output) down to 1
    put 0 before output
  end repeat
  return char 1 to pos of output
end

on Del t
  set stopTime to the ticks + t
  repeat while the ticks < stopTime
  end repeat
end

on clipText theString, theWidth
  set the text of member "textClipTestField" to theString
  set stringRight to the locH of charPosToLoc(member "textClipTestField", length(theString))
  if stringRight > theWidth then
    set theString to char 1 to locToCharPos(member "textClipTestField", point(theWidth, 0)) - 1 of theString & "..."
  end if
  return theString
end

on getNthOfPath theString, itemOffset
  if gPlatForm then
    set the itemDelimiter to ":"
  else
    set the itemDelimiter to "\"
  end if
  if itemOffset then
    set pathNameSeparator to the itemDelimiter
  end if
  if voidp(itemOffset) then
    return item 1 of theString & the itemDelimiter
  end if
  return item the number of items in theString - itemOffset of theString & pathNameSeparator
end

on changePalette platFormID
  set paletteNumber to the number of member ("RuntimePalette" & platFormID) of castLib 3
  if paletteNumber = -1 then
    alert("CBA2 internal error: no runtime palette present!" & RETURN & RETURN & "RuntimePalette" & platFormID)
    exit
  end if
  set the locH of sprite 2 to 9000
  updateStage()
  set the media of member "activePalette" to the media of member paletteNumber
end

on modKeyPressed
  if gPlatForm then
    return the commandDown
  else
    return the controlDown
  end if
end

on checkOrder
  exit
  set the textFont of member "order" to "geneva"
  set s to EMPTY
  repeat with i = 1 to 50
    if the locH of sprite i < 640 then
      if the isBalloon of sprite(i) then
        put "=" & RETURN after s
      else
        put "•" & RETURN after s
      end if
      next repeat
    end if
    put "o" & RETURN after s
  end repeat
  set the foreColor of field "order" to 255
  put s into field "order"
  repeat with i in the theSelection of gObj1
    set the foreColor of line i of field "order" to 14
  end repeat
end

on convert str, whichChar
  repeat with i = 1 to length(str)
    if charToNum(char i of str) = whichChar then
      put "@" into char i of str
    end if
  end repeat
  return str
end

on stripReturns input, theReturnChar
  repeat while 1
    set returnPos to offset(RETURN, input)
    if not returnPos then
      exit repeat
    end if
    put theReturnChar into char returnPos of input
  end repeat
  repeat while 1
    if the last char in input = theReturnChar then
      delete char -30000 of input
      next repeat
    end if
    exit repeat
  end repeat
  return input
end

on addReturns input, theReturnChar
  repeat while 1
    set returnPos to offset(theReturnChar, input)
    if not returnPos then
      exit repeat
    end if
    put RETURN into char returnPos of input
  end repeat
  return input
end

on OpenDocs thePathsList
  if listp(thePathsList) then
    if count(thePathsList) then
      if not (the frameLabel = "CBA2") then
        changePalette("Mac")
        startProgram()
        go("CBA2")
        cursor(0)
      end if
      openFile(gObj5, 1, 1, getAt(thePathsList, 1))
    end if
  end if
end

on updateVersionNo
  if the movieName contains ".dir" then
    set vers to char offset("_", the movieName) + 1 to length(the movieName) - 4 of the movieName
  else
    set vers to char length(the movieName) - 1 to length(the movieName) of the movieName
  end if
  put "v." & vers into field "vers"
  if gPlatForm then
    set the textFont of field "vers" to "Geneva"
  else
    set the textFont of field "vers" to "Arial"
  end if
end
